#ifndef _KGR_PATCH_BSC1108963_H
#define _KGR_PATCH_BSC1108963_H

#include <asm/compat.h>

int kgr_patch_bsc1108963_init(void);
static inline void kgr_patch_bsc1108963_cleanup(void) {}


struct linux_binprm;

int kgr_copy_strings_kernel(int argc, const char *const *__argv,
			    struct linux_binprm *bprm);
int kgr_remove_arg_zero(struct linux_binprm *bprm);
int kgr_do_execve(const char *filename,
		  const char __user *const __user *__argv,
		  const char __user *const __user *__envp);
asmlinkage long kgr_sys_execve(const char __user *filename,
			const char __user *const __user *argv,
			const char __user *const __user *envp);
asmlinkage long kgr_compat_sys_execve(const char __user * filename,
				      const compat_uptr_t __user * argv,
				      const compat_uptr_t __user * envp);

#define KGR_PATCH_BSC1108963_FUNCS					\
	KGR_PATCH(copy_strings_kernel, kgr_copy_strings_kernel),	\
	KGR_PATCH(remove_arg_zero, kgr_remove_arg_zero),		\
	KGR_PATCH(do_execve, kgr_do_execve),				\
	KGR_PATCH(SyS_execve, kgr_sys_execve),				\
	KGR_PATCH(compat_sys_execve, kgr_compat_sys_execve),		\

#endif /* _KGR_PATCH_BSC1108963_H */
